// DlgProxy.cpp : implementation file
//
/*
PLAY_ITW.EXE v0.03a : Player for Impulse Tracker modules files
Copyright (C) 1998  Olivier AUMAGE
E-mail : Olivier.Aumage@ens-lyon.fr
Web : http://www.ens-lyon.fr/~oaumage/

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	  You should have received a copy of the GNU General Public License
	  along with this program; if not, write to the Free Software
	  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "stdafx.h"
#include "Play_ITw.h"
#include "DlgProxy.h"
#include "Play_ITwDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPlay_ITwDlgAutoProxy

IMPLEMENT_DYNCREATE(CPlay_ITwDlgAutoProxy, CCmdTarget)

CPlay_ITwDlgAutoProxy::CPlay_ITwDlgAutoProxy()
{
	EnableAutomation();
	
	// To keep the application running as long as an OLE automation 
	//	object is active, the constructor calls AfxOleLockApp.
	AfxOleLockApp();

	// Get access to the dialog through the application's
	//  main window pointer.  Set the proxy's internal pointer
	//  to point to the dialog, and set the dialog's back pointer to
	//  this proxy.
	ASSERT (AfxGetApp()->m_pMainWnd != NULL);
	ASSERT_VALID (AfxGetApp()->m_pMainWnd);
	ASSERT_KINDOF(CPlay_ITwDlg, AfxGetApp()->m_pMainWnd);
	m_pDialog = (CPlay_ITwDlg*) AfxGetApp()->m_pMainWnd;
	m_pDialog->m_pAutoProxy = this;
}

CPlay_ITwDlgAutoProxy::~CPlay_ITwDlgAutoProxy()
{
	// To terminate the application when all objects created with
	// 	with OLE automation, the destructor calls AfxOleUnlockApp.
	//  Among other things, this will destroy the main dialog
	AfxOleUnlockApp();
}

void CPlay_ITwDlgAutoProxy::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CPlay_ITwDlgAutoProxy, CCmdTarget)
	//{{AFX_MSG_MAP(CPlay_ITwDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CPlay_ITwDlgAutoProxy, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CPlay_ITwDlgAutoProxy)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_IPlay_ITw to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {EDB4C8FA-2ACF-11D1-B35E-DCE971BF2962}
static const IID IID_IPlay_ITw =
{ 0xedb4c8fa, 0x2acf, 0x11d1, { 0xb3, 0x5e, 0xdc, 0xe9, 0x71, 0xbf, 0x29, 0x62 } };

BEGIN_INTERFACE_MAP(CPlay_ITwDlgAutoProxy, CCmdTarget)
	INTERFACE_PART(CPlay_ITwDlgAutoProxy, IID_IPlay_ITw, Dispatch)
END_INTERFACE_MAP()

// The IMPLEMENT_OLECREATE2 macro is defined in StdAfx.h of this project
// {EDB4C8F8-2ACF-11D1-B35E-DCE971BF2962}
IMPLEMENT_OLECREATE2(CPlay_ITwDlgAutoProxy, "Play_ITw.Application", 0xedb4c8f8, 0x2acf, 0x11d1, 0xb3, 0x5e, 0xdc, 0xe9, 0x71, 0xbf, 0x29, 0x62)

/////////////////////////////////////////////////////////////////////////////
// CPlay_ITwDlgAutoProxy message handlers
