// pointers.h: interface for the c_envelope_node class.
//
//////////////////////////////////////////////////////////////////////
/*
PLAY_ITW.EXE v0.03a : Player for Impulse Tracker modules files
Copyright (C) 1998  Olivier AUMAGE
E-mail : Olivier.Aumage@ens-lyon.fr
Web : http://www.ens-lyon.fr/~oaumage/

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	  You should have received a copy of the GNU General Public License
	  along with this program; if not, write to the Free Software
	  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#if !defined(POINTERS_H)
#define POINTERS_H

#define NB_MIXERS 4

struct s_coefs
{
	double a ;
	double b ;
	double c ;
	double d ;
};

typedef struct s_coefs coefs, *p_coefs ;

typedef class c_envelope *p_envelope ;
typedef class c_envelope_node *p_envelope_node ;
typedef class c_instrument *p_instrument ;
typedef class c_mixer *p_mixer ;
typedef class c_wav *p_wav ;
typedef class c_module *p_module ;
typedef class c_note_sample *p_note_sample ;
typedef class c_pattern *p_pattern ;
typedef class c_real_channel *p_real_channel ;
typedef class c_sample *p_sample ;
typedef class c_virtual_channel *p_virtual_channel ;
typedef class c_driver *p_driver ;

#endif // POINTERS_H